// Filename: USERCODE.C                                     
// "WINETEST" Generated by WinMaker Pro.                    
// Author:                                                  

#include "WINDOWS.H"
#include "WINETEST.H"

WMPDEBUG
#include "USERCODE.WMC"
    
    
#include <stdio.h>

HANDLE DebugMutex;
int Log_FirstRun = 0;
char WorkingDir[MAX_PATH];
char debug_file[MAX_PATH];
char debug_override_file[MAX_PATH];

#define CP_PRODSTRING "XERAS"
#define VER_MAJOR 1
#define VER_MINOR 0
#define VER_TRIVIAL 1
#define VER_SUB ""


int TestLinuxSystem();


/** TimeString accepts pointers to two strings and fills the strings with the
*** current local date and time respectively.
**/
void TimeString(char* mytime, char* mydate)
{
  time_t sec;

#ifdef WIN32
  SYSTEMTIME systime;

  if(mytime)
    *mytime = 0;
  if(mydate)
    *mydate = 0;

  sec = 1;

  if(sec >= 0)
  {
    GetLocalTime(&systime);

    if(mytime)
      sprintf(mytime,"%02d:%02d:%02d",systime.wHour, systime.wMinute, systime.wSecond);
    if(mydate)
      sprintf(mydate,"%02d/%02d/%04d",  systime.wMonth, systime.wDay, systime.wYear);
  }
  else
  {
    if(mytime)
      sprintf(mytime,"02:01:02");
    if(mydate)
      sprintf(mydate,"08/26/1971");
  }


#else
  struct tm tim;

  sec = time(NULL);
  memset(&tim, 0, sizeof(struct tm));
  localtime_r(&sec, &tim);
  if(mytime)
    sprintf(mytime,"%02d:%02d:%02d",tim.tm_hour, tim.tm_min, tim.tm_sec);
  if(mydate)
    sprintf(mydate,"%02d/%02d/%04d",  tim.tm_mon+1, tim.tm_mday, 1900+tim.tm_year);

#endif

}

int Winlib_PrintErrno(int err, int stuff , int stuff2, BOOL boolstuff)
{
  printf("errno = %d\n", err);
  return 1;
}



void LogMessage(char* msg, int timestamp)
{
/*
#ifdef DISKERASE
  return;
#else
*/

  FILE* fp = NULL;
  char timestr[24], datestr[24], old_file[MAX_PATH], old_file2[MAX_PATH];
   int i;

  timestr[0] = 0;
  datestr[0] = 0;


  #if defined(LINUXDEBUGGING)
  printf(msg);
  #endif



  if(Log_FirstRun)
  {

    if(WorkingDir[0] == 0)
      strcpy(WorkingDir, ".");

    Log_FirstRun = 0;
 //   MessageBox(NULL, "DebugMessage first run 1", "LogMessage()", MB_OK);

    DebugMutex = CreateMutex(NULL, FALSE, NULL);

    debug_override_file[0] = 0;

    old_file[0] = old_file2[0] = 0;

    if(debug_file[0] == 0)
      sprintf(debug_file, "%s/Debug_%s.txt",  WorkingDir, CP_PRODSTRING);
    ConvertPath(debug_file);

#if defined(LINUXDEBUGGING)
    printf("%s\n", debug_file);
#endif

    i = 1;
#ifndef DISKERASE
    sprintf(old_file, "%s/Debug_%s_prev.txt",  WorkingDir, CP_PRODSTRING);
    sprintf(old_file2, "%s/Debug_%s_prev2.txt",  WorkingDir, CP_PRODSTRING);

    ConvertPath(old_file);
    ConvertPath(old_file2);


#if defined(XERASE)
    DeleteFile(old_file2);
    if(old_file[0] && FileSize(old_file))
      i = MoveFile(old_file, old_file2);
#endif

    DeleteFile(old_file);
    if (debug_file[0] && FileSize(debug_file))
      i = MoveFile(debug_file, old_file);
#endif

    fp = fopen(debug_file, "wt");
    if(!fp)
    {
#if defined(LINUXDEBUGGING)
      printf("Can not open file for debug messages!\n");
#endif
      MessageBox(NULL, "Can not open file for debug messages!!", debug_file, MB_OK | MB_ICONSTOP);
      return;
    }


   // MessageBox(NULL, "DebugMessage first run 2", "LogMessage()", MB_OK);


    TimeString(timestr, datestr);


    fprintf(fp, "Startup Date: %s     Time: %s\n", datestr, timestr);
    fprintf(fp, "     Version: %d.%d.%d%s\n", VER_MAJOR, VER_MINOR, VER_TRIVIAL, VER_SUB);
    fprintf(fp, "---------------------------------------------------\n\n");


    if(!i)
      fprintf(fp, "Could not make backup (%s) of previous debug_file\n\n", old_file);
  }


	if (debug_file[0] == 0)
	{
		fclose(fp);
		return;
	}

   // MessageBox(NULL, "DebugMessage first run 3", "LogMessage()", MB_OK);
  if(DebugMutex)
    WaitForSingleObject(DebugMutex, 10000);


  //  MessageBox(NULL, "DebugMessage first run 4", "LogMessage()", MB_OK);

  // Get incident time/date
  if(timestamp)
    TimeString(timestr, datestr);


  if(!fp)
    fp = fopen(debug_file, "at");

  if(fp)
  {
    if(timestamp && datestr[0] && timestr[0])
      fprintf(fp,"[%s  %s]  ", datestr, timestr);

    fprintf(fp,"%s",  msg);
    fflush(fp);
    fclose(fp);
  }

  if(DebugMutex)
    ReleaseMutex(DebugMutex);
//#endif
}


